﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;

namespace MoveAPointLocation
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Map.MapUnit = GeographyUnit.DecimalDegree;

            LayerOverlay baseMap = new LayerOverlay();
           


            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\Program Files\ThinkGeo\Map Suite Desktop Full Edition 3.0 (BETA)\Samples\SampleData\Data\countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            baseMap.Layers.Add(worldLayer);

            LayerOverlay houseOverlay = new LayerOverlay();
            InMemoryFeatureLayer houses = new InMemoryFeatureLayer();
            Feature house = new Feature(-96, 48);
            houses.InternalFeatures.Add(house);

            houses.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle( PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Blue), 15);
            houses.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            houseOverlay.Layers.Add("houses", houses);


            worldLayer.Open();
            Map.CurrentExtent = worldLayer.GetBoundingBox();
            worldLayer.Close();
            Map.Overlays.Add("basemap", baseMap);
            Map.Overlays.Add("houseOverlay", houseOverlay);
            Map.Refresh();
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            LayerOverlay housesOverlay = (LayerOverlay)Map.Overlays["houseOverlay"];
            InMemoryFeatureLayer houses = (InMemoryFeatureLayer)housesOverlay.Layers["houses"];
            Map.EditOverlay.Lock.EnterWriteLock();
            Map.EditOverlay.EditShapesLayer.InternalFeatures.Add(houses.InternalFeatures[0]);
            Map.EditOverlay.CalculateAllControlPoints();
            Map.EditOverlay.Lock.ExitWriteLock();
            Map.Refresh();
           
        }

        private void button2_Click(object sender, EventArgs e)
        {

            LayerOverlay housesOverlay = (LayerOverlay)Map.Overlays["houseOverlay"];
            InMemoryFeatureLayer houses = (InMemoryFeatureLayer)housesOverlay.Layers["houses"];
         
            housesOverlay.Lock.EnterWriteLock();
            houses.EditTools.BeginTransaction();         
            houses.FeatureSource.UpdateFeature(Map.EditOverlay.EditShapesLayer.InternalFeatures[0]);
            houses.EditTools.CommitTransaction();
            housesOverlay.Lock.ExitWriteLock();

            Map.EditOverlay.Lock.EnterWriteLock();
            Map.EditOverlay.EditShapesLayer.InternalFeatures.Clear();
            Map.EditOverlay.Lock.ExitWriteLock();
            Map.Refresh();
        }
    }
}       
